<?php

add_action("widgets_init", array('CuteGalleryWidget', 'register'));


class CuteGalleryWidget extends WP_Widget {

	function register() { 

		register_widget("CuteGalleryWidget");

	}

	function CuteGalleryWidget() {

		$widget_ops = array('classname' => 'CuteGalleryWidget', 'description' => 'Displays a random image from a selected gallery, or from all galleries.' );

		$this->WP_Widget('CuteGalleryWidget', 'CG Random Image', $widget_ops);

	}

	function update($new_instance, $old_instance) { 

		$instance = $old_instance;

		$instance['title'] = $new_instance['title'];
		$instance['gallery_id'] = $new_instance['gallery_id'];

		return $instance;

	}

	function form($instance) { 

		$instance = wp_parse_args( (array) $instance, array( 'title' => 'Random Image', 'gallery_id' => '0' ) );

		$title = $instance['title'];
		$gallery_id = $instance['gallery_id'];

		?>

		<p>

			<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Widget Title:'); ?> </label>

			<input type="text" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" value="<?php echo attribute_escape($title); ?>"><br>
			
			<label for="<?php echo $this->get_field_id('gallery_id'); ?>"><?php _e('Gallery ID:'); ?> </label>
			<input type="text" id="<?php echo $this->get_field_id('gallery_id'); ?>" name="<?php echo $this->get_field_name('gallery_id'); ?>" value="<?php echo attribute_escape($gallery_id); ?>">

		</p>

		<?php

	}

	function widget($args, $instance){
		global $wpdb; 
		
		if($instance['gallery_id'] > 0) { 
			$allimgs = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix."cutegallery_images WHERE gallery_id='".$instance['gallery_id']."'");
			$rand = rand(1,$allimgs);
			$rand = $rand - 1;
			$img = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."cutegallery_images WHERE gallery_id='".$instance['gallery_id']."' LIMIT 1 OFFSET ".$rand);
		} else { 
			$allimgs = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix."cutegallery_images");
			$rand = rand(1,$allimgs);
			$rand = $rand - 1;
			$img = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."cutegallery_images LIMIT 1 OFFSET ".$rand);
		}
		
		if($img) { 
			echo $args['before_widget'];
	
			$title = empty($instance['title']) ? ' ' : apply_filters('widget_title', $instance['title']);
	
			if (!empty($title)) {
	
				echo '<h3 class="widget-title">' . $title . '</h3>';
	
			} 
			
			echo '<div class="textwidget">';
			echo '<p align="center">';
			echo '<a href="'.cutegallery_PLUGIN_URL.'/images/'.$img->image.'" class="cutegallery-fancybox" rel="random_img" title="'.esc_attr($img->caption).'"><img class="cutegallery_image" alt="" src="'.cutegallery_PLUGIN_URL.'/images/side/'.$img->image.'" width="'.cutegallery_SIDE_WIDTH.'"></a>';
			echo '</p>';
			echo '</div>';
	
			echo $args['after_widget'];
		}

	}

}


?>